<?php
namespace Teknisa\PLA\Modules\Requisicao\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;

class Pla03800HistoricoDeRequisicao extends \Zeedhi\Framework\Controller\Report {

    protected $reportService;
    protected $dataSourceManager;
    protected $environment;
    protected $qr2Strategy;
    protected $birtStrategy;
    
    public function __construct($reportService, $dataSourceManager, $environment, $qr2Strategy, $birtStrategy) {
     
      $this->dataSourceManager = $dataSourceManager;
      $this->qr2Strategy = $qr2Strategy;
      $this->birtStrategy = $birtStrategy;
      $this->environment = $environment; 
      parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'Pla03800' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'Pla03802' =>  array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'Pla03803' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'Pla03801' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI',
                'NRORG'           => 'P_NRORG'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();

        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        
        if($row['P_TCDOPERADOR'] == 'T'){
            $row['P_CDOPERADOR'] = $row['P_TCDOPERADOR']; 
        }
        
        // if ($row['P_CDSERVFILI'] == 'T') 
        //     $this->mountListaServ($row);
        
        $row['NRORG'] = $this->environment->getNrOrg();
    }

    public function mountListaServ($row) {
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $row['P_CDFILIAL'],
            ),
            array(
                'columnName' => 'NRORG',
                'operator' => '=',
                'value' => $row['NRORG'],
            )
        );

        $filterCriteria = new FilterCriteria('servico', $conditions);
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);

        $servicos = $dataSet->getRows();
        $row['P_CDSERVFILI'] = '';
        foreach($servicos as $servico){
            $row['P_CDSERVFILI'] = $row['P_CDSERVFILI'].'_'.$servico['CDSERVFILI'];
        }
    }
}